// background.js
console.log('我是后台js...');
//
function util_getdomainhost(website=''){
    if(website){
        return website.replace('https://','').replace('http://','')
            .replace('www','').replace('/','');
    }
    return website;
}
//
function util_isnumber(val){
    var regPos = /^[0-9]+.?[0-9]*/; //判断是否是数字。
    if(regPos.test(val) ){
        return true;
    }else{
        return false;
    }
}

//从字符串中移除字符(除了数字)
function util_get_num(str = ''){
    let resultString = str.replace(/[^0-9]/g, '');
    resultString = resultString.trim();
    if(util_isnumber(resultString)){
        if(resultString.length >=7){
            return resultString;
        }
    }
    return '';
}

function util_get_websites(str=''){
    // 匹配 URL 的正则表达式
    var urlPattern = /https?:\/\/[-A-Za-z0-9+&@#/%?=~_|!:,.;]*[-A-Za-z0-9+&@#/%=~_|]/g;
    var urls = str.match(urlPattern);
    return urls;
}

function util_checkFanpa(str = ''){
    const searchString = "This item is sold out";
    const regex = new RegExp(searchString);
    const containsString = regex.test(str);
    if(containsString){
        return true;
    } else {
        return false;
    }
}

function util_getscript_ytInitialData_content(html=''){
    // 示例HTML代码
    // 正则表达式匹配<script>标签内容的模式
    var scriptTagPattern = /<script\b[^>]*>([\s\S]*?)<\/script>/gm;
    var matches = html.match(scriptTagPattern);
    if (matches) {
        for (var i = 0; i < matches.length; i++) {
            // 提取<script>标签里的内容
            var scriptContent = matches[i].replace(scriptTagPattern, '$1');
            if(scriptContent.indexOf('var ytInitialData') !=-1){
               return scriptContent;
            }
        }
    }
    return false;
}

function util_check_containsNumber(inputString) {
    var regex = /\d/; // 正则表达式，匹配数字
    return regex.test(inputString);
}

function util_del_character(str = ''){
 return str.replace(/[^0-9+()]/g, '');
}

function util_get_page_whatsapp_num(html = ''){
    let _whatsapp_num = '';
    var $html = $(html);
    //
    $html.find('a').each(function () {
        let _a_href = $(this).attr('href');
        if (_a_href) {
            if(_a_href && (_a_href.indexOf('whatsapp') !=-1 || _a_href.indexOf('+') !=-1) && util_check_containsNumber(_a_href)){
                let _a_href_ =  util_del_character(_a_href);
                if(_a_href_.length < 15 && _a_href_.length >=7){
                    _whatsapp_num = _a_href_;
                    return _whatsapp_num;
                }
            }
        }
    });
    //
    $html.find('p').each(function () {
        let str = $(this).text();
        str = str.toLowerCase();
        if(str && (str.indexOf('whatsapp') !=-1 || str.indexOf('+') !=-1) && util_check_containsNumber(str)){
            let _str =  util_del_character(str);
            if(_str && _str.indexOf('+')!=-1){
                let _str_arr = _str.split('+');
                let _whatsapp_num = _str_arr[1];
                if(_whatsapp_num.length >=6 && _whatsapp_num.length<15){
                    return _whatsapp_num;
                }
            }
        }
    });
    $html.find('span').each(function () {
        let str = $(this).text();
        str = str.toLowerCase();
        if(str && (str.indexOf('whatsapp') !=-1 || str.indexOf('+') !=-1) && util_check_containsNumber(str)){
            let _str =  util_del_character(str);
            if(_str && _str.indexOf('+')!=-1){
                let _str_arr = _str.split('+');
                let _whatsapp_num = _str_arr[1];
                if(_whatsapp_num.length >=6 && _whatsapp_num.length<15){
                    return _whatsapp_num;
                }
            }
        }
    });
    $html.find('li').each(function () {
        let str = $(this).text();
        str = str.toLowerCase();
        if(str && (str.indexOf('whatsapp') !=-1 || str.indexOf('+') !=-1) && util_check_containsNumber(str)){
            let _str =  util_del_character(str);
            if(_str && _str.indexOf('+')!=-1){
                let _str_arr = _str.split('+');
                let _whatsapp_num = _str_arr[1];
                if(_whatsapp_num.length >=6 && _whatsapp_num.length<15){
                    return _whatsapp_num;
                }
            }
        }
    });

    $html.find('dd').each(function () {
        let str = $(this).text();
        str = str.toLowerCase();
        if(str && (str.indexOf('whatsapp') !=-1 || str.indexOf('+') !=-1) && util_check_containsNumber(str)){
            let _str =  util_del_character(str);
            if(_str && _str.indexOf('+')!=-1){
                let _str_arr = _str.split('+');
                let _whatsapp_num = _str_arr[1];
                if(_whatsapp_num.length >=6 && _whatsapp_num.length<15){
                    return _whatsapp_num;
                }
            }
        }
    });

    return _whatsapp_num;
}

function util_get_page_tel(html = ''){
    let tel = '';
    var $html = $(html);
    $html.find('a').each(function () {
        let _a_href = $(this).attr('href');
        if (_a_href) {
            if(_a_href.indexOf('tel') !=-1 && util_check_containsNumber(_a_href)){
                let _a_href_fomrat = _a_href.replace('tel','').replace(':','').replaceAll('/','');
                if(_a_href_fomrat.length < 15 && _a_href_fomrat.length >=7){
                    tel = _a_href_fomrat;
                    return;
                }
            }
        }
    });
    //
    if(tel == ''){
        $(".phone,.tel,.whatsapp,.telephone,div[class*='phone'],p[class*='phone'],li[class*='phone'],span[class*='phone']").each(function (){
            let str = $(this).text();
            str = str.toLowerCase();
            if(util_check_containsNumber(str)){
                str = str.trim();
                str = str.replaceAll(':','').replaceAll('(','')
                        .replaceAll(')','')
                        .replaceAll('/','');
                if(str.length >=7 && str.length < 15){
                    tel = str;
                    return;
                }
            }
        });
    }
    //
    if(tel  == '') {
        $html.find('p').each(function () {
            let str = $(this).text();
            str = str.toLowerCase();
            if (str && str.indexOf('whatsapp') == -1 && util_check_containsNumber(str) &&
                (str.indexOf('tel')!=-1 || str.indexOf('phone')!=-1 || str.indexOf('call')!=-1 || str.indexOf('mobile')!=-1 || str.indexOf('+')!=-1 || str.indexOf('86')!=-1)
            ) {
                let _str = util_del_character(str);
                _str = _str.trim();
                _str = _str.replaceAll(':','').replaceAll('(','')
                    .replaceAll(')','')
                    .replaceAll('/','');
                //
                if(_str.length >=7 && _str.length < 15){
                    if(_str.indexOf('+')!=-1){
                        let _firstChar = _str.charAt(0);
                        if(_firstChar=='+'){
                            tel = _str;
                            return;
                        }
                    }else{
                        tel = _str;
                        return;
                    }
                }
            }
        });
    }
    if(tel  == '') {
        $html.find('span').each(function () {
            let str = $(this).text();
            str = str.toLowerCase();
            if (str && str.indexOf('whatsapp') == -1 && util_check_containsNumber(str)
                && (str.indexOf('tel')!=-1 || str.indexOf('phone')!=-1 || str.indexOf('call')!=-1 || str.indexOf('mobile')!=-1 || str.indexOf('+')!=-1 || str.indexOf('86')!=-1)
            ) {
                let _str = util_del_character(str);
                _str = _str.trim();
                _str = _str.replaceAll(':','').replaceAll('(','')
                    .replaceAll(')','')
                    .replaceAll('/','');
                if(_str.length >=7 && _str.length < 15){
                     if(_str.indexOf('+')!=-1){
                        let _firstChar = _str.charAt(0);
                        if(_firstChar=='+'){
                            tel = _str;
                            return;
                        }
                     }else{
                        tel = _str;
                        return;
                     }
                }
            }
        });
    }
    if(tel  == '') {
        $html.find('li').each(function () {
           let str = $(this).text();
            str = str.toLowerCase();
            if(str && str.indexOf('whatsapp') ==-1 && util_check_containsNumber(str)
                && (str.indexOf('tel')!=-1 || str.indexOf('phone')!=-1 || str.indexOf('call')!=-1 || str.indexOf('mobile')!=-1 || str.indexOf('+')!=-1 || str.indexOf('86')!=-1)
            ){
                let _str =  util_del_character(str);
                _str = _str.trim();
                _str = _str.replaceAll(':','').replaceAll('(','')
                    .replaceAll(')','')
                    .replaceAll('/','');
                if(_str.length >= 7 && _str.length < 15){
                     if(_str.indexOf('+')!=-1){
                        let _firstChar = _str.charAt(0);
                        if(_firstChar=='+'){
                            tel = _str;
                            return;
                        }
                     }else{
                        tel = _str;
                        return;
                     }
                }
            }
        });
    }
    if(tel  == '') {
        $html.find('dd').each(function () {
           let str = $(this).text();
            str = str.toLowerCase();
            if(str && str.indexOf('whatsapp') ==-1 && util_check_containsNumber(str)
                && (str.indexOf('tel')!=-1 || str.indexOf('phone')!=-1 || str.indexOf('call')!=-1 || str.indexOf('mobile')!=-1 || str.indexOf('+')!=-1 || str.indexOf('86')!=-1)
            ){
                let _str =  util_del_character(str);
                _str = _str.trim();
                _str = _str.replaceAll(':','').replaceAll('(','')
                    .replaceAll(')','')
                    .replaceAll('/','');
                if(_str.length >= 7 && _str.length < 15){
                     if(_str.indexOf('+')!=-1){
                        let _firstChar = _str.charAt(0);
                        if(_firstChar=='+'){
                            tel = _str;
                            return;
                        }
                     }else{
                        tel = _str;
                        return;
                     }
                }
            }
        });
    }
    return tel;
}

function selectPhoneNumber(str) {
    const phoneReg = /(1[0-9]{10})|([0-9]{3,4})?[0-9]{7,12}/g;//匹配手机号或者固话
    const num = str.replace(/\s|[(]|[)]|[（]|[）]|[-]*/g, '');//去除字符串中所有空格、小括号和横杠
    const phone_arr = num.match(phoneReg);//识别手机号或者固话（在字符串内检索指定的值，或找到一个或多个正则表达式的匹配）
    let phone = '';
    if(phone_arr && phone_arr.length > 0){
        for(let i=0;i<phone_arr.length;i++){
            phone = phone_arr[i];
            if(phone.indexOf('86') != -1 || phone.indexOf('0755') != -1){
                break;
            }
        }
    }
    return phone;
}

function util_get_wechat(str = ''){
    let wechat = '';
    str = str.toLowerCase();
    if(str && (str.indexOf('wechat') !=-1)){
        str = str.replaceAll('whatsapp','');
        str = str.replaceAll('/','');
        str = str.replaceAll('.','');
        str = str.replaceAll(':','');
        str = str.replaceAll('：','');
        let str_arr = str.split('wechat');
        if(str_arr.length >= 1){
            let str_temp = str_arr[1];
            let str_temp_arr = str_temp.split(' ');
            wechat = str_temp_arr[0];
            if(str_temp_arr.length > 1){
                let may_wechat_num = str_temp_arr[1];
                if(util_check_containsNumber(may_wechat_num)){
                    wechat += may_wechat_num;
                }
            }
            if(wechat == ''){
                let may_item = '';
                for(let i=0;i<str_temp_arr.length;i++){
                    may_item = str_temp_arr[i];
                    if(may_item.length>3){
                        wechat = may_item;
                    }
                }
            }

            wechat = wechat.replaceAll(':','');
            if(wechat == '?' || wechat == '？' || wechat == 'html'){
                wechat = '';
            }
            if(wechat.length <=3){
                wechat = '';
            }
            //

            //
        }
    }
    return wechat;
}

function util_get_emails_from_list(email_list = []){
    let _emails = '';
    var forbidden_keys = ['1.8.1','.cart', '.index', '.collection',
            '.js', 'template.404','tel:', 'mailto:', '.jpg', '.pdf', '.doc',
            '.xls', '.xlsx', '.png', '.jpeg', '.webp', '.gif', 'javascript:',
            'skype', '#', 'None', '.svg', 'desktop.ts', 'example', 'css', '.studio', 'image', 'jquery', 'swiper', 'myshopline.com',
            'img_', 'xxx.xxx', 'foundation-sites', 'exemple@mail.com', 'exemple@gmail.be', 'exemple@mail.ch', 'john@email.com',
            'your.email@address.com', 'stores@domain.com', 'test@email.com', 'first.last@company.com', 'you@email.com', 'your-email@shopify.com',
            'ada@ada.lt', 'johndoe@domain.com', 'your@email.com', 'jane.smith@email.com', 'abc@xyz.com', 'user@domain.com', 'template.account@template.blog',
            'john@test.com', 'emily@test.com', 'email@domain.com', 'yourname@email.com', 'jill@mail.com', 'joebloggs@email.com', 'abc@abc.abc', 'support@domain.com',
        'yellow@hello.com','you@domain.com'];
    for(let en=0;en<email_list.length;en++){
        let _temp_email = email_list[en];
        if(_temp_email.length < 40){
            if(forbidden_keys.includes(_temp_email) == false){
                _emails+=_temp_email+',';
            }
        }
    }
    if(_emails){
        return _emails.slice(0, -1);
    }
    return '';
}

function plugin_set_expire(expire,callback){
    chrome.storage.local.set({expire: expire}, callback);
}

function plugin_get_expire(callback){
    chrome.storage.local.get('expire', callback);
}

function google_shopify_keyword_set(values, callback){
    chrome.storage.local.set({google_shopify_keywords: values}, callback);
}

function google_shopify_keyword_get(callback){
    chrome.storage.local.get('google_shopify_keywords', callback);
}

function extractEmails (text) {
    text = text.replaceAll('<b>', '').replaceAll('</b>', '');
    return text.match(/([a-zA-Z0-9._-]+@[a-zA-Z0-9._-]+\.[a-zA-Z0-9._-]+)/gi);
}

function get_emails_filter(emails = []){
    var forbidden_keys = ['1.8.1','.cart', '.index', '.collection',
            '.js', 'template.404','tel:', 'mailto:', '.jpg', '.pdf', '.doc',
            '.xls', '.xlsx', '.png', '.jpeg', '.webp', '.gif', 'javascript:',
            'skype', '#', 'None', '.svg', 'desktop.ts', 'example', 'css', '.studio', 'image', 'jquery', 'swiper', 'myshopline.com',
            'img_', 'xxx.xxx', 'foundation-sites', 'exemple@mail.com', 'exemple@gmail.be', 'exemple@mail.ch', 'john@email.com',
            'your.email@address.com', 'stores@domain.com', 'test@email.com', 'first.last@company.com', 'you@email.com', 'your-email@shopify.com',
            'ada@ada.lt', 'johndoe@domain.com', 'your@email.com', 'jane.smith@email.com', 'abc@xyz.com', 'user@domain.com', 'template.account@template.blog',
            'john@test.com', 'emily@test.com', 'email@domain.com', 'yourname@email.com', 'jill@mail.com', 'joebloggs@email.com', 'abc@abc.abc', 'support@domain.com', 'yellow@hello.com'];
    var domain_emails = [];
    if(emails && emails.length>0){
        for(j=0;j<emails.length;j++){
            var current_email = emails[j];
            current_email = current_email.toLowerCase().trim();
            //把字符串最后一个.移除掉
            if(current_email[current_email.length-1] == '.'){
                current_email = current_email.slice(0,-1);
            }
            //排除有些如 .png
            var is_forbidden = false;
            for(k=0;k<forbidden_keys.length;k++){
                if(current_email.indexOf(forbidden_keys[k])!=-1){
                    is_forbidden = true;
                    break;
                }
            }
            //leaflet@1.8.0
            let current_email_arr = current_email.split('@');
            if(current_email_arr.length > 1){
                let current_a_houzhui = current_email_arr[1];
                let current_a_houzhui_arr = current_a_houzhui.split('.');
                let is_num_shuliang = 0;
                for(let k=0;k<current_a_houzhui_arr.length;k++){
                    if(util_isnumber(current_a_houzhui_arr[k])){
                        is_num_shuliang +=1;
                    }
                }
                if(is_num_shuliang >=2){
                    is_forbidden = true;
                }
            }
            //
            if(current_email.length > 30){
                is_forbidden = true;
            }
            //
            if(!is_forbidden && !domain_emails.includes(current_email)){
                domain_emails.push(current_email);
            }
            //
        }
    }
    return domain_emails;
}

function ajax_get(url){
    console.log('ajax get url:'+url);
    let _html_result = '';
    var exhibitors_ajax = $.ajax({
             //url: 'https://www.google.com/maps/place/VIP+Wigs+%26+Prosthesis/@37.9009282,-122.0623831,17z/data=!3m1!4b1!4m6!3m5!1s0x808561953bedbbfd:0xe9365860131da46b!8m2!3d37.9009282!4d-122.0623831!16s%2Fg%2F1tcxpx4r?authuser=0&hl=en',
             url:url,
             data: {},
             type: 'GET',
             async:false,
             crossDomain: true,
             timeout:5000,//5 s
             dataType: 'html',
             contentType:'text/html; charset=utf-8',
             //dataType: 'json',
             //contentType:'application/json;charset=utf-8',
             success: function(data) {
                 _html_result = data;
             },
             error: function(xhr, textStatus, errorThrown) {
                _html_result = 'error';
            }
         });
    return _html_result;
}

function pause_switch(callback){
    chrome.storage.local.get(null, function(items) {
        //
        let prefix = 'pause';
        if (!items.hasOwnProperty(prefix)) {
            chrome.storage.local.set({pause: 1}, callback);
        }else{
            if(items[prefix] == 1){
                chrome.storage.local.set({pause: 0}, callback);
            }else{
                chrome.storage.local.set({pause: 1}, callback);
            }
        }
    });
}

function pause_list_switch(callback){
    chrome.storage.local.get(null, function(items) {
        //
        let prefix = 'pause_list';
        if (!items.hasOwnProperty(prefix)) {
            chrome.storage.local.set({pause_list: 1}, callback);
        }else{
            if(items[prefix] == 1){
                chrome.storage.local.set({pause_list: 0}, callback);
            }else{
                chrome.storage.local.set({pause_list: 1}, callback);
            }
        }
    });
}

function request_shangjia_company_page_link_ajax(storage_key=''){
    chrome.storage.local.get(null, function(items) {
        let need_item = items[storage_key];
        //need_item['Website'] = 'https://wholesalehempandcbd.com';
        console.log('request_shangjia_company_page_link_ajax:'+need_item['Website']);
        //
        if(need_item['Website'] == ''){
          //
          need_item['_is_request'] = 2;
          let obj = {};
          obj[storage_key] = need_item;
               chrome.storage.local.set(obj, function (){
          });
          //
        }else{
            $.ajax({
                url:need_item['Website'],
                timeout : 5000, //超时时间设置，单位毫秒
                data: {},
                type: 'GET',
                async:true,
                dataType: 'html',
                contentType:'text/html; charset=utf-8',
                crossDomain: true,
                cache: false,
                success: function(data) {
                    var $html = $(data);
                   //
                    let emails = extractEmails(data);
                    let domain_emails = get_emails_filter(emails);
                    //
                    $html.find('a').each(function (){
                        let _a_href = $(this).attr('href');
                        if(_a_href){
                            //
                            if(_a_href.indexOf('facebook') != -1){
                                need_item['SNS_facebook'] = _a_href;
                            }
                            if(_a_href.indexOf('twitter') != -1){
                                need_item['SNS_twitter'] = _a_href;
                            }
                            if(_a_href.indexOf('instagram') != -1){
                                need_item['SNS_instagram'] = _a_href;
                            }
                            if(_a_href.indexOf('pinterest') != -1){
                                need_item['SNS_pinterest'] = _a_href;
                            }
                            if(_a_href.indexOf('linkedin') != -1){
                                need_item['SNS_linkedin'] = _a_href;
                            }
                            if(_a_href.indexOf('youtube') != -1){
                                need_item['SNS_youtube'] = _a_href;
                            }
                            if(_a_href.indexOf('tiktok') != -1){
                                need_item['SNS_tiktok'] = _a_href;
                            }
                             if(_a_href.indexOf('t.me') != -1 || _a_href.indexOf('whatsapp') != -1){
                                need_item['SNS_whatsapp'] = _a_href;
                            }
                        }
                    });
                   //
                    if(domain_emails.length > 0){
                        //
                        need_item['Email_Address'] = util_get_emails_from_list(domain_emails);
                        //
                        console.log('get email');
                        console.log(need_item['Email_Address']);
                        //
                    }
                    //let phones = selectPhoneNumber(data);
                    let _tel = util_get_page_tel(data);
                    let _whatsapp_num = util_get_page_whatsapp_num(data);
                    need_item['Phone'] = _tel;
                    need_item['Whatsapp Num'] = _whatsapp_num;
                    //
                    if(true){
                        var need_urls = [];
                        var need_cha_urls = ['contact', 'about', 'privacy', 'shipping', 'page', 'support', 'track', 'refund',
                            'policy', 'terms', 'conditions', 'faq', 'return', 'wholesale',
                            'refund', 'shipping', 'whatsapp', 'safety', 'quality',
                            'guide', 'service', 'affiliate', 'shippment', 'brand',
                            'followus'];
                        var domain_host = util_getdomainhost(need_item['Website']);
                        console.log('domain_host:'+domain_host);
                        $html.find('a').each(function (){
                            if(need_urls.length < 60){
                                var temp_href = $(this).attr('href');
                                if(typeof temp_href !== 'undefined'){
                                    if(temp_href.indexOf('http')==-1){
                                        if(temp_href.indexOf('/')!=-1){
                                            temp_href = need_item['Website']+temp_href;
                                        }else{
                                            temp_href = need_item['Website']+'/'+temp_href;
                                        }
                                    }
                                    for(let i=0; i<need_cha_urls.length;i++){
                                        if(temp_href.indexOf(need_cha_urls[i])!=-1 && temp_href.indexOf(domain_host)!=-1){
                                            if(!need_urls.includes(temp_href)){
                                                console.log('temp href add:'+temp_href);
                                                need_urls.push(temp_href);
                                                break;
                                            }
                                        }
                                    }
                                }
                                //
                            }
                        });
                        ////
                        for(let f=0; f<need_urls.length; f++){
                            let _html_result = ajax_get(need_urls[f]);
                            emails = extractEmails(_html_result);
                            domain_emails = get_emails_filter(emails);
                            if(domain_emails.length > 0){
                                if(need_item['Email_Address'] == ''){
                                    need_item['Email_Address'] = util_get_emails_from_list(domain_emails);
                                }else{
                                    //
                                    let _email_addresses = need_item['Email_Address'];
                                    let _email_address_arr = _email_addresses.split(',');
                                    for(let _e=0;_e<domain_emails.length;_e++){
                                        let _email_address = domain_emails[_e];
                                        _email_address = _email_address.trim();
                                        if(_email_address_arr.includes(_email_address) == false){
                                            _email_address_arr.push(_email_address);
                                        }
                                    }
                                    //
                                    need_item['Email_Address'] = util_get_emails_from_list(_email_address_arr);
                                }
                                //console.log('get email2');
                                //console.log(need_item['Email_Address']);
                                //break;
                            }
                            if(need_item['Phone'] == ''){
                                let _tel = util_get_page_tel(_html_result);
                                need_item['Phone'] = _tel;
                            }
                            if(need_item['Whatsapp Num'] == ''){
                                let _whatsapp_num = util_get_page_whatsapp_num(_html_result);
                                need_item['Whatsapp Num'] = _whatsapp_num;
                            }
                        }
                        ////
                    }
                    //

                   need_item['_is_request'] = 2;
                   let obj = {};
                   obj[storage_key] = need_item;
                   chrome.storage.local.set(obj, function (){
                   });
                   //
                },
                error: function( jqXHR, textStatus, errorThrown ) {
                    console.log( jqXHR, textStatus, errorThrown );
                    //
                    need_item['_is_request'] = 2;
                    need_item['_error'] = errorThrown;
                    let obj = {};
                    obj[storage_key] = need_item;
                    chrome.storage.local.set(obj, function (){
                        //
                        //
                    });
                    //
                }
            });
            //
        }
    })
}

function request_shangjia_company_page_link(){
    chrome.storage.local.get(null, function(items) {
        //判断请求是否超过5个
        let current_total_num = 0;
        for(let key in items) {
            if (key.indexOf('shangjia_about_contact_and_basic_info_') != -1) {
                if (items[key]['_is_request'] == 1 && items[key]['_s_time'] > (Date.now()-500000)) {
                    current_total_num += 1;
                }
            }
        }
        if(current_total_num >= 2){
            return;
        }
        //
        let need_item = null;
        for(let key in items){
            if(key.indexOf('shangjia_about_contact_and_basic_info_') != -1){
                if(items[key]['_is_request'] == 0 || (items[key]['_is_request'] == 1 && items[key]['_s_time'] < (Date.now()-500000))){
                    need_item = items[key];
                    need_item['_is_request'] = 1;
                    need_item['_s_time'] = Date.now();
                    let obj = {};
                    obj[key] = need_item;
                    chrome.storage.local.set(obj, function (){
                        //
                        request_shangjia_company_page_link_ajax(key);
                        //
                    });
                    break;
                }
            }
        }
        //
    });
}
//
function xintiao(){
    chrome.storage.local.get(null, function(items) {
         if(items.hasOwnProperty('pause') == false || items['pause'] == 0){
             console.log('爬取中');
             request_shangjia_company_page_link();
         }else{
             console.log('已暂停爬取');
         }
    });

    chrome.storage.local.get(null, function(items) {
        console.log('items');
        console.log(items);
    });

    //let str = '';

    //let _dom = $(str);
    //https://www.facebook.com/gabriella.obi.77/about_work_and_education
    //
    //let _shangjia_company_page_link = _dom.find('.x1gan7if span.xvq8zen a.x1a2a7pz.xt0b8zv').attr('href');
    //console.log(_shangjia_company_page_link);

    //let _shangjia_company_page_name = _dom.find('.x1gan7if span.xvq8zen a.x1a2a7pz.xt0b8zv').text();
    //console.log(_shangjia_company_page_name);
}
xintiao();
setInterval(xintiao, 8000);

function storage_clear(){
    /*plugin_get_expire(function (callback_data){
        let expire_date = callback_data['expire'];
        if(typeof expire_date != 'undefined'){
            chrome.storage.local.clear(function(){
                console.log('remove all');
                plugin_set_expire(expire_date);
            })
        }else{
            chrome.storage.local.clear(function(){
                console.log('remove all');
            })
        }
    });*/
    //
    chrome.storage.local.get(null, function(items) {
        //
        let need_item = null;
        for (let key in items) {
            if (key.indexOf('shangjia_about_contact_and_basic_info_') != -1) {
                // 清空特定值
                chrome.storage.local.remove(key, function() {
                   console.log(`键名 ${key} 的值已被清空！`);
                });
            }

            if(key == 'shangjias' || key == 'data_process' || key == 'groupinfos'){
                // 清空特定值
                chrome.storage.local.remove(key, function() {
                   console.log(`键名 ${key} 的值已被清空！`);
                });
            }
        }
    });
    //
}
//
function get_data_process(){

    let total_add_shangjia_num = 0;
    let has_caiji_geren_num = 0;

    chrome.storage.local.get(null, function(items) {
        //
        for(let key in items){
            if(key.indexOf('shangjia_about_contact_and_basic_info_') != -1){
                total_add_shangjia_num += 1;
                if(items[key]['_is_request'] == 2){
                    has_caiji_geren_num += 1;
                }
            }
        }
        //
        let obj = {};
        obj['data_process'] = {
            'total_add_shangjia_num': total_add_shangjia_num,
            'has_caiji_geren_num': has_caiji_geren_num,
        }
        chrome.storage.local.set(obj, function (){
            //
            //
        });
        //
    });
}
//
function data_process_get(callback){
     /*chrome.storage.sync.get('domains', (res) => {
        console.log(res);
        return res;
     });*/
    chrome.storage.local.get('data_process', callback);
}

function storage_get(callback){
    chrome.storage.local.get(null, callback);
}

function filter_out_url(url=''){
    let filter_out_urls = ['youtube', 'made-in-china', 'google', 'yahoo', 'bing', 'facebook', 'twitter', 'instagram',
        'pinterest', 'amazon', 'temu', 'ebay', 'linkedin', 'csdn', 'dhgate', 'alibaba', 'similarweb', 'jetbrains',
        'sohu', 'walmart', 'yelp', 'cifnews', 'go4worldbusiness', 'douyin', 'dtkj', 'wikipedia', 'newwindow',
        'tiktok', '163', '52wmb'];
    var is_forbidden = false;
    for(k=0;k<filter_out_urls.length;k++){
        if(url.indexOf(filter_out_urls[k])!=-1){
            console.log('filter_out_url:'+url);
            is_forbidden = true;
            break;
        }
    }
    return is_forbidden;
}

function storage_shangjia_about_contact_and_basic_info_set(_shangjia_info={}, callback){
    //
    if(filter_out_url(_shangjia_info['Website']) == false){
        //
        let prefix = 'shangjia_about_contact_and_basic_info_'+$.md5(_shangjia_info['_shangjia_id']);
        //
        chrome.storage.local.get(null, function(items) {
            //
            if(!items.hasOwnProperty(prefix)){
                let obj = {};
                obj[prefix] = {
                    '_shangjia_id': _shangjia_info['_shangjia_id'],
                    'Website': _shangjia_info['Website'],
                    'Email_Address':'',
                    'Phone':'',
                    'Whatsapp Num':'',
                    'SNS_facebook':'',
                    'SNS_twitter':'',
                    'SNS_instagram':'',
                    'SNS_pinterest':'',
                    'SNS_linkedin':'',
                    'SNS_youtube':'',
                    'SNS_tiktok':'',
                    'SNS_whatsapp':'',
                    '_shangjia_add_time': Date.now(),
                    '_is_request':0
                };
                chrome.storage.local.set(obj, callback);
            }
            //
        });
        //
    }
}

async function fetch_request(url){
     var return_html = '';
     let options = {
         method: 'get',
         headers: {
             'Content-Type':'application/json;charset=utf-8'
         },
         // body: JSON.stringify(res)
     }
     // Fake api for making post requests
    //console.log('fetch_request url:'+url);
    await fetch(url,options)
        .then(res => res.text())
        .then(d => {
            //403错误也是直接到这里了
            console.log('post response:');
            //console.log(d);
            return_html = d;
        }).catch(function (){
            console.log('fetch_request error url:'+url);
            return_html = '';
        })
    return return_html;
}

function spider_request_fetch(url){
    console.log('spider_request_fetch:'+url);
    let return_html = fetch_request(url);
    return_html.then((data) => {
        if(data){
            console.log('fetch data');
            console.log(data);
        }else{
            //对于访问异常的请求,直接过滤

        }
    });
}

//监听扩展程序进程或内容脚本发送请求的请求
chrome.runtime.onMessage.addListener(
  function (request, sender, sendResponse) {
    if (request.action == 'shangjia_items_update') {
        console.log('action',request,sender,sendResponse);
        //
        let shangjia_infos = request.shangjia_infos;
        //
        for (let i=0;i<shangjia_infos.length;i++){
            storage_shangjia_about_contact_and_basic_info_set(shangjia_infos[i],function (){

            });
        }
        //
        sendResponse({state:'关键词填写成功！'});
    }else if(request.action  == 'can_zidong_caiji'){
        console.log('can_zidong_caiji',request,sender,sendResponse);
        //判断，如果加入超过3000个，则不能，而且需要已开启自动采集
        chrome.storage.local.get(null, function(items) {
           if(items.hasOwnProperty('pause_list') == false || items['pause_list'] == 0){
                //已开启
                let total_add_shangjia_num = 0;
                for(let key in items){
                    if(key.indexOf('shangjia_about_contact_and_basic_info_') != -1){
                        total_add_shangjia_num += 1;
                    }
                }
                if(total_add_shangjia_num < 3000){
                    sendResponse(JSON.stringify({state:0}));
                }else{
                    sendResponse(JSON.stringify({state:1}));
                }
                //
            }else{
                sendResponse(JSON.stringify({state:1}));
            }
        });
        //
        return true;
    }
  }
);

/**
 * 1.
 * chrome.runtime.onInstalled.addListener(details => {
  console.log('previousVersion', details.previousVersion);
});
2.
 //发送消息
 chrome.runtime.sendMessage({
        action: 'send',
        keyword: 'keyword value'
      }, function (response) {   //接收回调
        console.log(response);  //{state:'关键词填写成功！'}
      });

//监听扩展程序进程或内容脚本发送请求的请求
chrome.runtime.onMessage.addListener(
  function (request, sender, sendResponse) {
    if (request.action == 'send') {
      console.log('action',request,sender,sendResponse);
//  request {action: "send", keyword: "keyword value"}
 //sender  {id: "agkllkkjbhclhjnlebdbdagkagfgcecj", url: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj/popup.html", origin: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj"}
//sendResponse  ƒ () { [native code] }
      sendResponse({state:'关键词填写成功！'});
    }
  }
);
 */

function sendPopTips(msg = ''){
     chrome.runtime.sendMessage({
        action: 'background-tips',
        info: msg
      }, function (response) {   //接收回调
        console.log(response);  //{state:'关键词填写成功！'}
      });
}