function util_url_get_domain(url=''){
    url = url.replace('https://','');
    url = url.replace('http://','');
    url = url.replace('www.','');
    let urlArr = url.split('/');
    if(urlArr.length>0){
        return urlArr[0];
    }
    return '';
}

function util_getwebsite_url(url = ''){
    let urlString = url;
    let urlPattern = /^(https?:\/\/)?([^\/]+)\/.*/; // 匹配协议和域名部分
    let match = urlString.match(urlPattern);
    if (match) {
      let protocol = match[1] || 'http://'; // 如果没有协议，默认为 http
      let domain = match[2];
      return protocol+domain;
    } else {
      return url;
    }
}

function search_update_localStorage(){
    let current_url = window.location.href;
    if(current_url && current_url.indexOf('inurl')!=-1 && current_url.indexOf('collections')!=-1){
        let shangjia_infos_localStorage = [];
        let tj = 0;
        $('#rcnt .MjjYud').each(function (){
                tj = tj +1 ;
                console.log('tj:'+tj);
                let a_href_val = $(this).find('a').attr('href');
                if(a_href_val && a_href_val.indexOf('search?num')==-1){
                    let website = util_getwebsite_url(a_href_val);
                    if(website){
                        shangjia_infos_localStorage.push({
                            '_shangjia_id':website,
                            'Website': website
                        })
                    }
                }
                //
        });
        //
        var message = {
                    action: 'shangjia_items_update',
                    info: '',
                    shangjia_infos: shangjia_infos_localStorage
        };
        send_message_to_popup(message);
        //
    }
}

var navigation_url = '';
function perf_observer(list, obserer){
    //console.log('aa');
    //console.log(getNetworkRequests(list.getEntriesByType('resource')));
    performanceResourceList = list.getEntriesByType('resource');
    //console.log(performanceResourceList);
    for(i = 0; i<performanceResourceList.length; i++){
        performanceResourceItem = performanceResourceList[i];
        //console.log('abababa');
        //console.log(performanceResourceItem);
        if(performanceResourceItem['initiatorType'] == 'xmlhttprequest'){
            if(performanceResourceItem['name'].indexOf('search')!=-1){
                //console.log(performanceResourceItem['name']);
                console.log('bbbb'+performanceResourceItem['name']);
                //
                setTimeout(function() {
                      search_update_localStorage();
                  },1000);
            }
        }
    }
}
var observer_ = new PerformanceObserver(perf_observer);
//observer_.observe({entryTypes:['resource', 'navigation']});
observer_.observe({entryTypes:['resource', 'navigation', 'paint']});
//

$(document).ready(function(){
  console.log('document on load');
  setTimeout(function() {
      search_update_localStorage();
  },1000);
});

// get popup2content info
chrome.runtime.onMessage.addListener((request, sender, sendResponse) => {

})
//

//send message to pop
function send_message_to_popup(message={}){
    /*
    {
            action: 'extract-catalog-products-export-clean',
            info: ''
        }
     */
    console.log('shopify message');
    console.log(message);
    chrome.runtime.sendMessage(message,(msg)=>{
        console.log('答复',msg)
    })
}