function util_check_expire(expire_date=''){
    if(expire_date==''){
        return true;
    }
    expire_date = expire_date.replace('T00:00:00.000Z','');
    let now_date = new Date();
    expire_date_list = expire_date.split('-');
    expire_date_f = new Date(expire_date_list[0], (expire_date_list[1]-1), expire_date_list[2]);
    if (now_date > expire_date_f) {
        return true;
    }
    return false;
}

function util_check_is_maps_page(){
     //检测当前是否maps页面
    chrome.tabs.getSelected(null, function (tab) {
        var current_url =  tab.url;
        if(current_url){
            if(current_url.indexOf('maps')==-1){
                   chrome.tabs.create({ url: "https://www.google.com/maps/@40.7049686,-74.0119462,14.29z" });
            }
        }else{
            chrome.tabs.create({ url: "https://www.google.com/maps/@40.7049686,-74.0119462,14.29z" });
        }
    });
}

function get_expire(){
    var bg = chrome.extension.getBackgroundPage();
    bg.plugin_get_expire(function (callback_data){
        let expire_date = callback_data['expire'];
        if(typeof expire_date === 'undefined'){
            $('.jihuo').show();
            $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
            $('#message-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin?plugin=vip_maps' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
            return;
        }else{
            console.log('expire_date');
            console.log(expire_date);
            expire_date = expire_date.replace('T00:00:00.000Z','');
            $('#expire_date').html(expire_date);
            if (util_check_expire(expire_date)) {
                $('.jihuo').show();
                $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                $('#message-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin?plugin=vip_maps' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                return;
            }
        }
    });
}

get_expire();

function extract_catalog_products_export_clean(){
    $('#extract-catalog-products-export-clean').click(function (){
        //util_check_is_maps_page();
        //
        $('#message-info').html('<span style="font-size: 12px;">提取需要花费时间，请保持界面不动,处理中...</span>')
        console.log('extract-catalog-products-url');
        //
        var bg = chrome.extension.getBackgroundPage();
        bg.storage_get(function (callback_data) {
            console.log('extract_catalog_products_export_clean');
            console.log(callback_data);
            //
            let expire_date = callback_data['expire'];
            if(typeof expire_date === 'undefined'){
                $('.jihuo').show();
                $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                $('#message-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin?plugin=vip_maps' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                return;
            }else{
                console.log('expire_date');
                console.log(expire_date);
                expire_date = expire_date.replace('T00:00:00.000Z','');
                $('#expire_date').html(expire_date);
                if (util_check_expire(expire_date)) {
                    $('.jihuo').show();
                    $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                    $('#message-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin?plugin=vip_maps' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                    return;
                }
            }
            //
            let export_datas = [];
            //
            //
            for(let key in callback_data){
                if(key.indexOf('shangjia_about_contact_and_basic_info_') != -1){
                    //
                    let shangjia_about_contact_and_basic_info = callback_data[key];
                    let export_data_item = {
                        'Website': shangjia_about_contact_and_basic_info['Website'],
                        'Email_Address':shangjia_about_contact_and_basic_info['Email_Address'],
                        'Phone':shangjia_about_contact_and_basic_info['Phone'],
                        'Whatsapp Num':shangjia_about_contact_and_basic_info['Whatsapp Num'],
                        'SNS_facebook':shangjia_about_contact_and_basic_info['SNS_facebook'],
                        'SNS_twitter':shangjia_about_contact_and_basic_info['SNS_twitter'],
                        'SNS_instagram':shangjia_about_contact_and_basic_info['SNS_instagram'],
                        'SNS_pinterest':shangjia_about_contact_and_basic_info['SNS_pinterest'],
                        'SNS_linkedin':shangjia_about_contact_and_basic_info['SNS_linkedin'],
                        'SNS_youtube':shangjia_about_contact_and_basic_info['SNS_youtube'],
                        'SNS_tiktok':shangjia_about_contact_and_basic_info['SNS_tiktok'],
                        'SNS_whatsapp':shangjia_about_contact_and_basic_info['SNS_whatsapp'],
                        'is_request': shangjia_about_contact_and_basic_info['_is_request'] ==2 ? '已完成':'未'
                    }
                    export_datas.push(export_data_item);
                }
            }
            //
            console.log('export_datas');
            console.log(export_datas);
            //
            exportToExcel(export_datas, 'gycharm-shopify-export-'+Date.now(), "Sheet1");
            //
            $('#message-info').html('');
            //
        });
        //
    });
}

extract_catalog_products_export_clean();

function extract_catalog_products_clean(){
    $('#extract-catalog-products-clean').click(function (){
        //util_check_is_maps_page();
        //
        var bg = chrome.extension.getBackgroundPage();
        bg.storage_clear();
        //
    });
}

extract_catalog_products_clean();
//
function jihuo(){
    $('#jihuo_btn').click(function (){
        //util_check_is_maps_page();
        var jihuo_text = $('#jihuo_text').val();
        jihuo_text = jihuo_text.trim();
        $('#message-info').html('');
        if(jihuo_text==''){
            $('#message-info').html('<span style="color:red;">请输入激活码</span>');
            return;
        }
        //
        // other then GET
        let options = {
            method: 'GET',
            headers: {
                'Content-Type':'application/json;charset=utf-8'
            },
            //body: JSON.stringify(res)
        }
        // Fake api for making post requests
        let fetchRes = fetch( "https://api.gycharm.com/v1/plugin-chkpro/" + jihuo_text);
        fetchRes.then(res =>
            res.json()).then(d => {
                console.log('post response:');
                console.log(d);
                console.log(d['VAL']);
                //
                if (d['VAL'] === "NO_KEY") {
                    $('#message-info').html('<span style="color:red;">激活码不存在!</span>');
                }else if(d['VAL'] == 'HAS_BOUND'){
                    $('#message-info').html('<span style="color:red;">激活码已使用过!</span>');
                }else {
                    var expire_date = d['VAL'];
                    if (util_check_expire(expire_date) == false) {
                        var bg = chrome.extension.getBackgroundPage();
                        bg.plugin_set_expire(expire_date,function (){
                            expire_date = expire_date.replace('T00:00:00.000Z','');
                            $('#expire_date').html(expire_date);
                            $('.jihuo').hide();
                            $('#message-account-info').html('');
                        });
                      //
                    }else{
                        $('.jihuo').show();
                        $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                        $('#message-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin?plugin=vip_maps' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                        return;
                    }
                }
                //
            })
                //
    });
}
jihuo();

function shopify_search(){
    $('.form-shopify #form_shopify_submit').click(function (){
        var bg = chrome.extension.getBackgroundPage();
        bg.plugin_get_expire(function (callback_data) {
            let expire_date = callback_data['expire'];
            if (typeof expire_date === 'undefined') {
                $('.jihuo').show();
                $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                $('#message-account-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                return;
            } else {
                expire_date = expire_date.replace('T00:00:00.000Z', '');
                $('#expire_date').html(expire_date);
                if (util_check_expire(expire_date)) {
                    $('.jihuo').show();
                    $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                    $('#message-account-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                    return;
                }
            }
            //
            let as_q = $('.form-shopify #as_q').val();
            as_q = as_q.trim().replace("\\", '');
            if(as_q==''){
                alert("关键词不能为空！");
                return false;
            }
            let sns_shopify_country_val = $('.form-shopify select[name="shopify_country"]').val();
            let sns_shopify_tech_val = $('.form-shopify select[name="shopify_tech"]').val();
            let sns_shopify_maijia_val = $('.form-shopify select[name="shopify_maijia"]').val();
            //
            let url = 'https://www.google.com/search?';
            if(sns_shopify_tech_val == 'tech_shopify'){
                q = 'q='+as_q;
                if(sns_shopify_maijia_val){
                    q += '+'+'inurl:collections+"'+sns_shopify_maijia_val+'"+site:*'+sns_shopify_country_val+'+-pinterest+-ebay+-walmart+-amazon+-facebook+-yelp+-instagram';
                }else{
                    q += '+'+'inurl:collections+site:*'+sns_shopify_country_val+'+-pinterest+-ebay+-walmart+-amazon+-facebook+-yelp+-instagram';
                }
                url += q
                url += '&num=100&ie=utf-8&oe=utf-8';
            }
            //
            var bg = chrome.extension.getBackgroundPage();
            let google_shopify_keywords = {
                'as_q': as_q,
                'shopify_country': sns_shopify_country_val,
                'shopify_tech': sns_shopify_tech_val,
                'shopify_maijia':sns_shopify_maijia_val
            };
            bg.google_shopify_keyword_set(google_shopify_keywords,function (){
               //
                chrome.tabs.create({ url: url});
                //
            });
            //
        });
        //
    });
}
shopify_search();

function init_search_customer(){
    var bg = chrome.extension.getBackgroundPage();
    bg.google_shopify_keyword_get(function (callback_data) {
            let google_shopify_keywords = callback_data['google_shopify_keywords'];
            if (typeof google_shopify_keywords !== 'undefined') {
                let as_q_val = google_shopify_keywords['as_q'];
                let shopify_country_val = google_shopify_keywords['shopify_country'];
                let shopify_tech_val = google_shopify_keywords['shopify_tech'];
                let shopify_maijia_val = google_shopify_keywords['shopify_maijia'];

                $('.form-shopify #as_q').val(as_q_val);
                $('.form-shopify #shopify_country').val(shopify_country_val);
                $('.form-shopify #shopify_tech').val(shopify_tech_val);
                $('.form-shopify #shopify_maijia').val(shopify_maijia_val);

            }
    });
}
init_search_customer();
//
function extract_catalog_products_pause(){
    $('#extract-catalog-products-pause').click(function (){
        //
        var bg = chrome.extension.getBackgroundPage();
        bg.pause_switch(function (){
            bg.storage_get(function (callback_data) {
                if(callback_data['pause'] == 1){
                    $('#extract-catalog-products-pause').text('后台采集已暂停,可点击开启');
                }else{
                    $('#extract-catalog-products-pause').text('后台采集已开启,可点击暂停');
                }
            });
          //
        });
        //
    });
}
extract_catalog_products_pause();

function init(){
    var bg = chrome.extension.getBackgroundPage();
    bg.storage_get(function (callback_data) {
        if(callback_data['pause'] == 1){
            $('#extract-catalog-products-pause').text('后台采集已暂停,可点击开启');
        }else{
            $('#extract-catalog-products-pause').text('后台采集已开启,可点击暂停');
        }
    });
}
init();

function data_process(){
    //$('#message-info').html('加载中...');
    var bg = chrome.extension.getBackgroundPage();
    //
    bg.get_data_process();
    //
    bg.data_process_get(function (callback_data) {
        let data_process = callback_data['data_process'];
        let total_add_shangjia_num = 0;
        let has_caiji_geren_num = 0;

        if(typeof data_process !== 'undefined' ){
            total_add_shangjia_num = data_process['total_add_shangjia_num'];
            has_caiji_geren_num = data_process['has_caiji_geren_num'];
            //
            $('#data_process').html("<div style='padding-bottom: 10px;'>已添加<span>"+total_add_shangjia_num+"</span>独立站，已采集<span>"+has_caiji_geren_num+"</span>个</div>");
            //
        }
        //
    });
}
setTimeout(function() {
    data_process();
   setInterval(data_process, 8000);
},1000);

//从content接收信息
chrome.runtime.onMessage.addListener((req, send, sendRes) => {
    console.log("收到info:", req.info)
    console.log("收到action:", req.action)
    console.log("收到tbm_map_urls:", req.nums)

    if(req.action == 'update-shangjia-num'){
        var catalog_products_num = req.nums;
        $('.catalog-products-num').html(catalog_products_num);
    }

    //sendRes("popup已经收到")

  })
//
//
//get columns
function getColumns(paramData){

	var header = [];
	$.each(paramData[0], function (key, value) {
		//console.log(key + '==' + value);
		var obj = {}
		obj["headertext"] = key;
		obj["datatype"] = "string";
		obj["datafield"] = key;
		header.push(obj);
	});
	return header;
}

//
function exportToExcel(data, fileName, sheetName) {
  // Create a new workbook
  var wb = XLSX.utils.book_new();

  // Convert your data to an array of arrays (2D array)
  var wsData = XLSX.utils.json_to_sheet(data);

  // Add the worksheet to the workbook
  XLSX.utils.book_append_sheet(wb, wsData, sheetName);

  // Generate the Excel file and trigger a download
  XLSX.writeFile(wb, fileName + ".xlsx");
}